Public Class Form1
   Private WithEvents DSSM As FarPoint.Win.Spread.Model.DefaultSheetSelectionModel
   Dim StyleSizingSelectCollection As StyleSizingSelectCollection
   Dim Orders As ordercollection
   Private WithEvents BindingSource As New BindingSource
   Private WithEvents StyleBindingSource As New BindingSource
#Region "FarPoint CellTypes"
   Private textCellType As New FarPoint.Win.Spread.CellType.TextCellType
   Private GroupIdTextCellType As New FarPoint.Win.Spread.CellType.TextCellType
   Private currencyCellType As New FarPoint.Win.Spread.CellType.CurrencyCellType
   Private percentCellType As New FarPoint.Win.Spread.CellType.PercentCellType
   Private plansOnlyCheckBoxCellType As New FarPoint.Win.Spread.CellType.CheckBoxCellType
   Private uploadAsCheckBoxCellType As New FarPoint.Win.Spread.CellType.CheckBoxCellType
   Private dateTimeCellType As New FarPoint.Win.Spread.CellType.DateTimeCellType
   Private shipDateTimePickerCellType As New FarPoint.Win.Spread.CellType.DateTimeCellType
   Private penaltyDateTimePickerCellType As New FarPoint.Win.Spread.CellType.DateTimeCellType
   Private CurrencyCellType1 As New FarPoint.Win.Spread.CellType.CurrencyCellType
   Private CurrencyCellType2 As New FarPoint.Win.Spread.CellType.CurrencyCellType
#End Region

#Region "Constants"
   Private Const Order As Integer = 0
   Private Const SplitType As Integer = 2
   Private Const Units As Integer = 3
   Private Const Cost As Integer = 4
   Private Const Retail As Integer = 5
   Private Const PlanOnly As Integer = 6
   Private Const GroupId As Integer = 7
   Private Const UploadAs88 As Integer = 8
   Private Const ShipDate As Integer = 9
   Private Const PenaltyDate As Integer = 10
   Private Const CreateUser As Integer = 11
   Private Const CreateDate As Integer = 12
   Private Const UploadedUser As Integer = 13
   Private Const UploadedDate As Integer = 14
   Private Const ProcessedDate As Integer = 15
   Private Const OrderLines As Integer = 16

   Private Const ChildCode As Integer = 0
   Private Const ChildDesc As Integer = 1
   Private Const ChildLines As Integer = 2

   Private Const Child1Style As Integer = 0
   Private Const Child1Color As Integer = 1
   Private Const Child1Desc As Integer = 2
   Private Const Child1Stores As Integer = 3
   Private Const Child1Units As Integer = 4
   Private Const Child1Cost As Integer = 5
   Private Const Child1Retail As Integer = 6
   Private Const Child1Sizes As Integer = 7

   Private Const Child2Group As Integer = 0
   Private Const Child2Store As Integer = 1
   Private Const Child2Prepack As Integer = 2
   Private Const Child2Units As Integer = 3
   Private Const Child2Cost As Integer = 4
   Private Const Child2Retail As Integer = 5
   Private Const Child2Sizes As Integer = 6

   Private Const firstRow As Integer = 0
   Private Const firstStoreRow As Integer = 2
   Private Const OrderLineCheckbox As Integer = 0
   Private Const Mic As Integer = 1
   Private Const Style As Integer = 2
   Private Const Color As Integer = 3
   Private Const Description As Integer = 4
   Private Const OfferingCode As Integer = 5
   Private Const LinePackType As Integer = 6
   Private Const LinePoolPackType As Integer = 7
   Private Const Group As Integer = 8
   Private Const Major As Integer = 9
   Private Const Minor As Integer = 10
   Private Const SubClass As Integer = 11
   Private Const LineCost As Integer = 12
   Private Const LineRetail As Integer = 13
   Private Const StoreCount As Integer = 14
   Private Const Pooled As Integer = 15
   Private Const LineUnits As Integer = 16
   Private Const Dollars As Integer = 17
   Private Const Processed As Integer = 18
#End Region

   Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
      StyleSizingSelectCollection = New StyleSizingSelectCollection()
      PopulateStyleSpread(StyleSizingSelectCollection)
      DSSM = CType(FpSpread2_Sheet1.Models.Selection, FarPoint.Win.Spread.Model.DefaultSheetSelectionModel)
   End Sub

   ''' <summary>
   ''' Populate the style spread
   ''' </summary>

   Private Sub PopulateStyleSpread(ByVal styleSizingSelectCollection As StyleSizingSelectCollection)

      Try
         Dim topside As New FarPoint.Win.ComplexBorderSide(Drawing.Color.Black, 0)
         Dim leftside As New FarPoint.Win.ComplexBorderSide(Drawing.Color.Black, 0)
         Dim rightside As New FarPoint.Win.ComplexBorderSide(Drawing.Color.Black, 0)
         Dim bottomside As New FarPoint.Win.ComplexBorderSide(Drawing.Color.LightGray, 1)
         Dim border As New FarPoint.Win.ComplexBorder(leftside, topside, rightside, bottomside)

         StyleBindingSource.DataSource = Nothing
         StyleBindingSource.DataSource = styleSizingSelectCollection

         With FpSpread1

            'Set the Datasource
            .DataSource = Me.StyleBindingSource
            .EditModeReplace = True
            .AllowDragDrop = False
            .AllowDragFill = True
            .Sheets(0).ColumnCount = Processed + 1
            .TextTipPolicy = FarPoint.Win.Spread.TextTipPolicy.FloatingFocusOnly
            .Sheets(0).AutoGenerateColumns = False
            With .Sheets(0)
               .ColumnHeader.RowCount = 2
               .ColumnHeader.AutoSortIndex = .ColumnHeader.RowCount - 2
               .Columns(Mic, Dollars).ShowSortIndicator = False
               .Columns(Mic, Dollars).SortIndicator = FarPoint.Win.Spread.Model.SortIndicator.None

               .ColumnHeaderVisible = True
               .RowHeaderVisible = True

               .AllowNoteEdit = False
               .AutoCalculation = True
               .RowCount = styleSizingSelectCollection.Count

               .ColumnHeader.Rows(0, 1).Height = 17
               .ColumnHeader.Cells(0, OrderLineCheckbox).RowSpan = 2
               .ColumnHeader.Cells(0, OrderLineCheckbox).Value = "Order"
               .ColumnHeader.Cells(0, OrderLineCheckbox).VerticalAlignment = FarPoint.Win.Spread.CellVerticalAlignment.Center
               .Columns(OrderLineCheckbox).DataField = "PlaceOnOrder"
               .Columns(OrderLineCheckbox).Width = 50

               .Columns(Mic).DataField = "MicId"
               .Columns(Mic).Width = .Columns(Mic).GetPreferredWidth + 10
               .ColumnHeader.Cells(0, Mic).RowSpan = 2
               .ColumnHeader.Cells(0, Mic).Value = "Mic"
               .ColumnHeader.Cells(0, Mic).VerticalAlignment = FarPoint.Win.Spread.CellVerticalAlignment.Center

               .Columns(Style).DataField = "StyleName"
               .ColumnHeader.Cells(0, Style).RowSpan = 2
               .ColumnHeader.Cells(0, Style).Value = "Style"
               .ColumnHeader.Cells(0, Style).VerticalAlignment = FarPoint.Win.Spread.CellVerticalAlignment.Center
               .Columns(Style).Width = .Columns(Style).GetPreferredWidth + 10

               .Columns(Color).DataField = "ColorName"
               .ColumnHeader.Cells(0, Color).RowSpan = 2
               .ColumnHeader.Cells(0, Color).Value = "Color"
               .ColumnHeader.Cells(0, Color).VerticalAlignment = FarPoint.Win.Spread.CellVerticalAlignment.Center
               .Columns(Color).Width = .Columns(Color).GetPreferredWidth + 10

               .Columns(Description).DataField = "Description"
               .ColumnHeader.Cells(0, Description).RowSpan = 2
               .ColumnHeader.Cells(0, Description).Value = "Description"
               .ColumnHeader.Cells(0, Description).VerticalAlignment = FarPoint.Win.Spread.CellVerticalAlignment.Center
               .Columns(Description).Width = .Columns(Description).GetPreferredWidth + 10

               .Columns(OfferingCode).DataField = "OfferingCodeId"
               .ColumnHeader.Cells(.ColumnHeader.RowCount - 2, OfferingCode).Value = "Offering"
               .ColumnHeader.Cells(.ColumnHeader.RowCount - 1, OfferingCode).Value = "Code"
               .ColumnHeader.Cells(.ColumnHeader.RowCount - 2, OfferingCode).Border = border
               .ColumnHeader.Cells(.ColumnHeader.RowCount - 2, OfferingCode).VerticalAlignment = FarPoint.Win.Spread.CellVerticalAlignment.Bottom
               .ColumnHeader.Cells(.ColumnHeader.RowCount - 1, OfferingCode).VerticalAlignment = FarPoint.Win.Spread.CellVerticalAlignment.Top

               .Columns(OfferingCode).Width = 50

               .Columns(LinePackType).DataField = "PackTypeForControl"
               .ColumnHeader.Cells(.ColumnHeader.RowCount - 2, LinePackType).Value = "Pack"
               .ColumnHeader.Cells(.ColumnHeader.RowCount - 1, LinePackType).Value = "Type"
               .ColumnHeader.Cells(.ColumnHeader.RowCount - 2, LinePackType).Border = border
               .ColumnHeader.Cells(.ColumnHeader.RowCount - 2, LinePackType).VerticalAlignment = FarPoint.Win.Spread.CellVerticalAlignment.Bottom
               .ColumnHeader.Cells(.ColumnHeader.RowCount - 1, LinePackType).VerticalAlignment = FarPoint.Win.Spread.CellVerticalAlignment.Top
               .Columns(LinePackType).Width = 50

               .Columns(LinePoolPackType).DataField = "PoolPackTypeForControl"
               .ColumnHeader.Cells(.ColumnHeader.RowCount - 2, LinePoolPackType).Value = "Pool Pack"
               .ColumnHeader.Cells(.ColumnHeader.RowCount - 1, LinePoolPackType).Value = "Type"
               .ColumnHeader.Cells(.ColumnHeader.RowCount - 2, LinePoolPackType).Border = border
               .ColumnHeader.Cells(.ColumnHeader.RowCount - 2, LinePoolPackType).VerticalAlignment = FarPoint.Win.Spread.CellVerticalAlignment.Bottom
               .ColumnHeader.Cells(.ColumnHeader.RowCount - 1, LinePoolPackType).VerticalAlignment = FarPoint.Win.Spread.CellVerticalAlignment.Top
               .Columns(LinePoolPackType).Width = .Columns(LinePoolPackType).GetPreferredWidth
               ' The column will only show if the plan is a plan pool locations and there are lines with pool units.
               .Columns(LinePoolPackType).Visible = False

               .Columns(Group).DataField = "Group"
               .ColumnHeader.Cells(0, Group).RowSpan = 2
               .ColumnHeader.Cells(0, Group).Value = "Group"
               .ColumnHeader.Cells(0, Group).VerticalAlignment = FarPoint.Win.Spread.CellVerticalAlignment.Center
               .Columns(Group).Width = 50

               .Columns(Major).DataField = "MajorClassName"
               .ColumnHeader.Cells(0, Major).RowSpan = 2
               .ColumnHeader.Cells(0, Major).Value = "Major"
               .ColumnHeader.Cells(0, Major).VerticalAlignment = FarPoint.Win.Spread.CellVerticalAlignment.Center
               .Columns(Major).Width = 50

               .Columns(Minor).DataField = "MinorClassName"
               .ColumnHeader.Cells(0, Minor).RowSpan = 2
               .ColumnHeader.Cells(0, Minor).Value = "Minor"
               .ColumnHeader.Cells(0, Minor).VerticalAlignment = FarPoint.Win.Spread.CellVerticalAlignment.Center
               .Columns(Minor).Width = 50

               .Columns(SubClass).DataField = "SubClassName"
               .ColumnHeader.Cells(0, SubClass).RowSpan = 2
               .ColumnHeader.Cells(0, SubClass).Value = "Sub"
               .ColumnHeader.Cells(0, SubClass).VerticalAlignment = FarPoint.Win.Spread.CellVerticalAlignment.Center
               .Columns(SubClass).Width = 50

               .Columns(LineCost).DataField = "Cost"
               .ColumnHeader.Cells(0, LineCost).RowSpan = 2
               .ColumnHeader.Cells(0, LineCost).Value = "Cost"
               .ColumnHeader.Cells(0, LineCost).VerticalAlignment = FarPoint.Win.Spread.CellVerticalAlignment.Center
               .Columns(LineCost).CellType = CurrencyCellType2
               .Columns(LineCost).Width = 50

               .Columns(LineRetail).DataField = "Retail"
               .ColumnHeader.Cells(0, LineRetail).RowSpan = 2
               .ColumnHeader.Cells(0, LineRetail).Value = "Retail"
               .ColumnHeader.Cells(0, LineRetail).VerticalAlignment = FarPoint.Win.Spread.CellVerticalAlignment.Center
               .Columns(LineRetail).CellType = CurrencyCellType2
               .Columns(LineRetail).Width = .Columns(LineRetail).GetPreferredWidth + 20

               .Columns(StoreCount).DataField = "NumberOfStores"
               .ColumnHeader.Cells(0, StoreCount).RowSpan = 2
               .ColumnHeader.Cells(0, StoreCount).Value = "# Stores"
               .ColumnHeader.Cells(0, StoreCount).VerticalAlignment = FarPoint.Win.Spread.CellVerticalAlignment.Center
               .Columns(StoreCount).Width = 50

               .Columns(Pooled).DataField = "Pooled"
               .ColumnHeader.Cells(0, Pooled).RowSpan = 2
               .ColumnHeader.Cells(0, Pooled).Value = "Pooled"
               .ColumnHeader.Cells(0, Pooled).VerticalAlignment = FarPoint.Win.Spread.CellVerticalAlignment.Center
               .Columns(Pooled).Width = .Columns(Pooled).GetPreferredWidth
               .Columns(Pooled).Visible = False

               .Columns(LineUnits).DataField = "Units"
               .ColumnHeader.Cells(0, LineUnits).RowSpan = 2
               .ColumnHeader.Cells(0, LineUnits).Value = "Units"
               .ColumnHeader.Cells(0, LineUnits).VerticalAlignment = FarPoint.Win.Spread.CellVerticalAlignment.Center
               .Columns(LineUnits).Width = .Columns(LineUnits).GetPreferredWidth + 20

               .Columns(Dollars).DataField = "Dollars"
               .ColumnHeader.Cells(0, Dollars).RowSpan = 2
               .ColumnHeader.Cells(0, Dollars).Value = "Dollars"
               .ColumnHeader.Cells(0, Dollars).VerticalAlignment = FarPoint.Win.Spread.CellVerticalAlignment.Center
               .Columns(Dollars).CellType = CurrencyCellType1
               .Columns(Dollars).Width = .Columns(Dollars).GetPreferredWidth + 20

               .Columns(Processed).DataField = "Processed"
               .ColumnHeader.Cells(0, Processed).RowSpan = 2
               .ColumnHeader.Cells(0, Processed).Value = "Processed"
               .ColumnHeader.Cells(0, Processed).VerticalAlignment = FarPoint.Win.Spread.CellVerticalAlignment.Center
               .Columns(Processed).Width = .Columns(Processed).GetPreferredWidth


               .Columns(Mic, Processed).Locked = True
               .Columns(OrderLineCheckbox, Processed).VerticalAlignment = FarPoint.Win.Spread.CellVerticalAlignment.Center
               .Columns(OrderLineCheckbox, Processed).HorizontalAlignment = FarPoint.Win.Spread.CellHorizontalAlignment.Center
               .Columns(Mic, SubClass).HorizontalAlignment = FarPoint.Win.Spread.CellHorizontalAlignment.Left
               .Columns(LinePackType, LinePoolPackType).HorizontalAlignment = FarPoint.Win.Spread.CellHorizontalAlignment.Center
               .Columns(Group).HorizontalAlignment = FarPoint.Win.Spread.CellHorizontalAlignment.Center

               .AddUnboundRows(0, 1)
               .RowHeader.Cells(0, 0).RowSpan = 1
               .RowHeader.Cells.Get(0, 0).Value = "Totals"
               .RowHeader.Columns(0).Width = 40

               .Cells(0, 1, 0, .ColumnCount - 1).Locked = True
               .Cells.Get(0, 0).ColumnSpan = LineUnits
               .Rows(0).Locked = True
               .Cells(0, 0).CellType = textCellType
               .Cells(0, LineUnits).Formula = "SUM(" + .Cells(1, LineUnits).ToString() + ":" + .Cells(.RowCount - 1, LineUnits).ToString + ")"
               .Cells(0, Dollars).Formula = "SUM(" + .Cells(1, Dollars).ToString() + ":" + .Cells(.RowCount - 1, Dollars).ToString + ")"
               Dim border2 As New FarPoint.Win.LineBorder(Drawing.Color.Black, 3, False, False, False, True)
               .Cells(0, LineUnits, 0, Dollars).Border = border2
               .SetActiveCell(0, 0)
               .StartingRowNumber = 0
            End With
            .SetViewportTopRow(0, 0)
         End With

      Catch ex As Exception

         Throw
      Finally

      End Try
   End Sub

   Private Sub Button1_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Button1.Click
      PopulateSecondSpread()
   End Sub

   ''' <summary>
   ''' Loads the spread. 
   ''' </summary>

   Private Sub PopulateSecondSpread()
      Try
         ClearSpread(False)
         DSSM.ClearSelection()

         BindingSource.AllowNew = False
         Orders = New OrderCollection
         BindingSource.DataSource = Orders

         With FpSpread2
            FpSpread2.DataSource = Me.BindingSource
            .AutoClipboard = True
            .AllowDragFill = True
            .TextTipPolicy = FarPoint.Win.Spread.TextTipPolicy.FloatingFocusOnly
            .VerticalScrollBarPolicy = FarPoint.Win.Spread.ScrollBarPolicy.AsNeeded
            .EditModeReplace = True
            .Visible = False
            With .Sheets(0)
               .SelectionUnit = FarPoint.Win.Spread.Model.SelectionUnit.Row
               .StartingRowNumber = 0
               .AutoGenerateColumns = False
               FpSpread2.Sheets(0).Columns.Count = OrderLines + 1

               .Columns(Order).Label = "Order"
               .Columns(Order).DataField = "OrderId"
               .Columns(Order).Width = 64.0!
               .Columns(Order).VerticalAlignment = FarPoint.Win.Spread.CellVerticalAlignment.Center
               .Columns(Order).HorizontalAlignment = FarPoint.Win.Spread.CellHorizontalAlignment.Center
               .Columns(Order).CellType = textCellType

               .Columns(Mic).Label = "Mic"
               .Columns(Mic).DataField = "Mic"
               .Columns(Mic).Width = .Columns(Mic).GetPreferredWidth + 20
               .Columns(Mic).VerticalAlignment = FarPoint.Win.Spread.CellVerticalAlignment.Center
               .Columns(Mic).HorizontalAlignment = FarPoint.Win.Spread.CellHorizontalAlignment.Left
               .Columns(Mic).CellType = textCellType

               .Columns(SplitType).Label = "Split By"
               .Columns(SplitType).DataField = "SplitVariable"
               .Columns(SplitType).Width = .Columns(SplitType).GetPreferredWidth + 15
               .Columns(SplitType).VerticalAlignment = FarPoint.Win.Spread.CellVerticalAlignment.Center
               .Columns(SplitType).HorizontalAlignment = FarPoint.Win.Spread.CellHorizontalAlignment.Left
               .Columns(SplitType).CellType = textCellType

               .Columns(Units).Label = "Units"
               .Columns(Units).DataField = "Units"
               .Columns(Units).Width = 65.0!
               .Columns(Units).HorizontalAlignment = FarPoint.Win.Spread.CellHorizontalAlignment.Center
               .Columns(Units).VerticalAlignment = FarPoint.Win.Spread.CellVerticalAlignment.Center

               .Columns(Cost).Label = "Cost"
               .Columns(Cost).DataField = "Cost"
               .Columns(Cost).Width = .Columns(Cost).GetPreferredWidth + 20
               .Columns(Cost).HorizontalAlignment = FarPoint.Win.Spread.CellHorizontalAlignment.Center
               .Columns(Cost).VerticalAlignment = FarPoint.Win.Spread.CellVerticalAlignment.Center
               .Columns(Cost).CellType = currencyCellType

               .Columns(Retail).Label = "Retail"
               .Columns(Retail).DataField = "Retail"
               .Columns(Retail).Width = .Columns(Retail).GetPreferredWidth + 20
               .Columns(Retail).HorizontalAlignment = FarPoint.Win.Spread.CellHorizontalAlignment.Center
               .Columns(Retail).VerticalAlignment = FarPoint.Win.Spread.CellVerticalAlignment.Center
               .Columns(Retail).CellType = currencyCellType

               .Columns(PlanOnly).Label = "AIMS Creation"
               .Columns(PlanOnly).DataField = "PlanOnly"
               .Columns(PlanOnly).Width = 90.0!
               .Columns(PlanOnly).HorizontalAlignment = FarPoint.Win.Spread.CellHorizontalAlignment.Center
               .Columns(PlanOnly).VerticalAlignment = FarPoint.Win.Spread.CellVerticalAlignment.Center
               .Columns(PlanOnly).CellType = plansOnlyCheckBoxCellType

               .Columns(GroupId).Label = "Group Id"
               .Columns(GroupId).DataField = "GroupId"
               .Columns(GroupId).Width = .Columns(GroupId).GetPreferredWidth
               .Columns(GroupId).HorizontalAlignment = FarPoint.Win.Spread.CellHorizontalAlignment.Center
               .Columns(GroupId).VerticalAlignment = FarPoint.Win.Spread.CellVerticalAlignment.Center
               .Columns(GroupId).CellType = GroupIdTextCellType

               .Columns(UploadAs88).Label = "Upload As"
               .Columns(UploadAs88).DataField = "UploadAsDiv88"
               .Columns(UploadAs88).Width = 100.0!
               .Columns(UploadAs88).HorizontalAlignment = FarPoint.Win.Spread.CellHorizontalAlignment.Center
               .Columns(UploadAs88).VerticalAlignment = FarPoint.Win.Spread.CellVerticalAlignment.Center
               .Columns(UploadAs88).CellType = uploadAsCheckBoxCellType
               .Columns(UploadAs88).Visible = False

               .Columns(ShipDate).Label = "Ship Date"
               .Columns(ShipDate).DataField = "ShipDate"
               .Columns(ShipDate).Width = 81.0!
               .Columns(ShipDate).HorizontalAlignment = FarPoint.Win.Spread.CellHorizontalAlignment.Center
               .Columns(ShipDate).VerticalAlignment = FarPoint.Win.Spread.CellVerticalAlignment.Center
               .Columns(ShipDate).CellType = shipDateTimePickerCellType

               .Columns(PenaltyDate).Label = "Penalty Date"
               .Columns(PenaltyDate).DataField = "CancelDate"
               .Columns(PenaltyDate).Width = 86.01
               .Columns(PenaltyDate).HorizontalAlignment = FarPoint.Win.Spread.CellHorizontalAlignment.Center
               .Columns(PenaltyDate).VerticalAlignment = FarPoint.Win.Spread.CellVerticalAlignment.Center
               .Columns(PenaltyDate).CellType = penaltyDateTimePickerCellType

               .Columns(CreateUser).Label = "Created By"
               .Columns(CreateUser).DataField = "CreateUserName"
               .Columns(CreateUser).Width = 84.0!
               .Columns(CreateUser).HorizontalAlignment = FarPoint.Win.Spread.CellHorizontalAlignment.Center
               .Columns(CreateUser).VerticalAlignment = FarPoint.Win.Spread.CellVerticalAlignment.Center
               .Columns(CreateUser).CellType = textCellType

               .Columns(CreateDate).Label = "Create Date"
               .Columns(CreateDate).DataField = "CreateDate"
               .Columns(CreateDate).Width = 84.0!
               .Columns(CreateDate).HorizontalAlignment = FarPoint.Win.Spread.CellHorizontalAlignment.Center
               .Columns(CreateDate).VerticalAlignment = FarPoint.Win.Spread.CellVerticalAlignment.Center
               .Columns(CreateDate).CellType = dateTimeCellType

               .Columns(UploadedUser).Label = "Uploaded By"
               .Columns(UploadedUser).DataField = "UploadedUserName"
               .Columns(UploadedUser).Width = 84.0!
               .Columns(UploadedUser).HorizontalAlignment = FarPoint.Win.Spread.CellHorizontalAlignment.Center
               .Columns(UploadedUser).VerticalAlignment = FarPoint.Win.Spread.CellVerticalAlignment.Center
               .Columns(UploadedUser).CellType = textCellType

               .Columns(UploadedDate).Label = "Uploaded Date"
               .Columns(UploadedDate).DataField = "UploadedDate"
               .Columns(UploadedDate).Width = 84.0!
               .Columns(UploadedDate).HorizontalAlignment = FarPoint.Win.Spread.CellHorizontalAlignment.Center
               .Columns(UploadedDate).VerticalAlignment = FarPoint.Win.Spread.CellVerticalAlignment.Center
               .Columns(UploadedDate).CellType = dateTimeCellType
               .Columns(UploadedDate).Locked = True

               .Columns(ProcessedDate).Label = "Processed Date"
               .Columns(ProcessedDate).DataField = "ProcessedDate"
               .Columns(ProcessedDate).Width = 90.0!
               .Columns(ProcessedDate).HorizontalAlignment = FarPoint.Win.Spread.CellHorizontalAlignment.Center
               .Columns(ProcessedDate).VerticalAlignment = FarPoint.Win.Spread.CellVerticalAlignment.Center
               .Columns(ProcessedDate).CellType = dateTimeCellType

               .Columns(OrderLines).DataField = "OrderOfferingCodes"
               .Columns(OrderLines).Visible = False

               'Prevents PlanOnly,GroupId,UploadAs,ShipDate cells from being editable if order has been uploaded.
               For rowIndex As Integer = 0 To .Rows.Count - 1
                  If .Cells(rowIndex, (UploadedUser)).Text > String.Empty Then
                     .Cells(rowIndex, (PlanOnly)).Locked = True
                     .Cells(rowIndex, (GroupId)).Locked = True
                     .Cells(rowIndex, (UploadAs88)).Locked = True
                     .Cells(rowIndex, (ShipDate)).Locked = True
                  End If
               Next

               If Orders.Count > 0 Then
                  .AddUnboundRows(0, 1)
                  .RowHeader.Cells(0, 0).RowSpan = 1
                  .RowHeader.Cells.Get(0, 0).Value = "Totals"
                  .RowHeader.Columns(0).Width = .RowHeader.Columns(0).GetPreferredWidth

                  .Cells.Get(0, 0).ColumnSpan = 3
                  .Rows(0).Locked = True
                  .Cells(0, PlanOnly).CellType = textCellType
                  .Cells(0, PlanOnly).Text = " "
                  .Cells(0, UploadAs88).CellType = textCellType
                  .Cells(0, UploadAs88).Text = " "
                  .Cells.Get(0, PlanOnly).ColumnSpan = .ColumnCount - 7
                  .SetRowExpandable(0, False)
                  If FpSpread2.Sheets(0).RowCount > 1 Then
                     .Cells(0, Units).Formula = "SUM(" + .Cells(1, Units).ToString() + ":" + .Cells(.RowCount - 1, Units).ToString + ")"
                     .Cells(0, Cost).Formula = "SUM(" + .Cells(1, Cost).ToString() + ":" + .Cells(.RowCount - 1, Cost).ToString + ")"
                     .Cells(0, Retail).Formula = "SUM(" + .Cells(1, Retail).ToString() + ":" + .Cells(.RowCount - 1, Retail).ToString + ")"
                  End If
                  Dim border2 As New FarPoint.Win.LineBorder(Drawing.Color.Black, 3, False, False, False, True)
                  .Cells(0, Units, 0, Retail).Border = border2

                  .ColumnHeaderVisible = True
                  .RowHeaderVisible = True
               End If
            End With
            .Visible = True
         End With

         FpSpread2.SetViewportTopRow(0, 0)
      Catch ex As Exception

         Throw
      Finally

      End Try
   End Sub

   Private Sub ClearSpread(ByVal visible As Boolean)

      Try
         FpSpread2_Sheet1.ColumnHeaderVisible = visible
         FpSpread2_Sheet1.RowHeaderVisible = visible

         BindingSource.DataSource = New BindingSource

         FpSpread2_Sheet1.Rows.Remove(0, FpSpread2_Sheet1.Rows.Count)
         FpSpread2_Sheet1.Columns.Remove(0, FpSpread2_Sheet1.Columns.Count)

      Catch ex As Exception

         Throw
      Finally

      End Try
   End Sub
End Class
